### wegGAKlasse.py

# Mutationswahrscheinlichkeit und Selektionswahrscheinlichkeit
# sind positive ganze Zahlen zwischen 0 und 100 ( also % )


### Hilfsfunktionen
import random
import math
### ===== Abstand ====================================================
def abstand(ort1,ort2):
    # berechnet den Abstand zweier Städte
    x1,y1=ort1
    x2,y2=ort2
    return math.sqrt((x1-x2)**2+(y1-y2)**2)

### ===== bewerte ===================================================
def bewerte(tour, faktor):
    # Die Bewertungsfunktion berechnet die Summe der geometrischen
    # Abstände (Luftliniendistanz) der Rundtour.
    summe=0
    for i in range(len(tour)-1):
        if (len(tour[i])!=2) or (len(tour[i+1])!=2):
            print(tour[i],tour[i+1])
            input('Fehler in bewerte!')
        if (tour[i][1]>100) or (tour[i+1][1]>100): # and?
            summe+=faktor*abstand(tour[i],tour[i+1])
##        elif tour[i][1]>100: # waere Alternative
##            summe+=faktor/2*abstand(tour[i],tour[i+1])
##        elif tour[i+1][1]>100:
##            summe+=faktor/2*abstand(tour[i],tour[i+1])
        else:
            summe+=abstand(tour[i],tour[i+1])
    return summe

### ===== besserP ===================================================
# Das Prädikat 'besserP' ist das Vergleichsprädikat zur Bewertung und
# ist daher vom speziellen Problem abhängig. Hier wird die vorgegebene
# Funktion bewerte (s.o.) genommen.
def besserP(individuum1, individuum2, faktor):
   return bewerte (individuum1, faktor) < bewerte (individuum2, faktor)

### ===== aktionP ===================================================
# Hilfsfunktion (Praedikat), die entscheidet, ob eine Aktion stattfindet
# oder nicht. Die Entscheidung hängt von der übergebenen ganzzahligen
# Wahrscheinlichkeit p ab. 0 < p < 100
def aktionP(p):
    return (random.randint(1,100) <= p)

### ===== waehle-Positionen =========================================
# Hilfsfunktion
# Wählt zwei verschiedene Zahlen aus {0 .. n-1} fuer die Position des
# Schnitts in den "Genen" aus und gib sie als Liste  zurück. 
# Die Zahlen sind stets geordnet: [klein gross]
# Unzulässige Parameter für n lösen einen Fehler aus!
def waehlePositionen(n):
    if type(n)!=int: return [0,n-1]
    if n<2: return[0,0]
    z1=random.randint(0,n-1)
    z2=random.randint(0,n-1)
    if (0 in[z1,z2]) and (n-1 in[z1,z2]):
        return waehlePositionen(n) # keine Auswahl, noch einmal versuchen
    if z1<z2: return [z1,z2]
    if z2<z1: return [z2,z1]
    return waehlePositionen(n) # gleich, noch einmal versuchen

### ===== Zufallsgenerator-setzen ====================================
# Setzt den Zufallsgenerator
# Das fuehrt bei erneutem Aufruf zur selben Folge
#random.seed(100)

### ===== Klasse WegGA ===============================================
class WegGA():

    def __init__(self, bildBreite=100,bildHoehe=600):
        self.bildBreite=bildBreite
        self.bildHoehe=bildHoehe
        self.anzahlOrte = 10 # Punkte ohne Startpunkt
        self.schrittDaten=[]
        self.verzoegerungsFaktor=5

    def setzeAnzahlOrte(self, anzahl):
        self.anzahlOrte = anzahl

    def gibOrte(self):
        return self.orteListe

    def erzeugeEinenOrt(self,x):
        # eine ort ist ein Zahlenpaar
        # Strasse 100 in der Hoehe!
        return (x, random.randint(0,self.bildHoehe))

    def erzeugeIndividuum(self):
        # Erzeugt ein Individuum der Population.
        orteListe = [(0,100)] # auf der Strassenkante
        for i in range(1,self.anzahlOrte):
            orteListe.append(self.erzeugeEinenOrt(i*self.bildBreite//(self.anzahlOrte)))
        orteListe.append((self.bildBreite,self.bildHoehe))
        ##print(orteListe)
        return orteListe

    def erzeugePopulation(self,anzahl=5):
        # Erzeugt die Grundpopulation für den genetischen Prozess.
        # Parameter sind: Anzahl der Individuen und die Städteliste
        # Wert: Eine Liste von Individuen
        population = []
        for i in range(anzahl):
            population.append(self.erzeugeIndividuum())
        return population

    def mutiere(self, individuum):
        # Mutiert ein einzelnes Individuum.
        # Dazu werden die y-Werte von zwei Orten veraendert
        # Individuum -> Individuum
        orte=[]+individuum # echte Kopie
        vorn,hinten = waehlePositionen(len(individuum)-2) # Raender weg!
        vorn+=1
        hinten+=1
        x1,y1=orte[vorn]
        orte[vorn]=(x1,y1+40*random.random())
        x2,y2=orte[hinten]
        orte[hinten]=(x2,y2+40*random.random())
        return orte

    def mutation(self, population, pMutatioon):
        # Steuert die Mutation für die gesamte Population.
        # Die bei der Mutation neu erzeugten Individuen werden der Population
        # hinzugefügt, dadurch ändert sich die Gesamtzahl. Deren Anpassung
        # erfolgt bei der Selektion.
        # Parameter sind: Population, Mutationswahrscheinlichkeit (pMutatioon)
        # Wert: Population zuzüglich der Mutierten
        mutierte = []
        for individuum in population:
            if aktionP(pMutatioon):
                mutierte.append(self.mutiere(individuum))
            else:
                mutierte.append(individuum)
        return population+mutierte


    def kreuze(self, individuum1, individuum2):
        # Kreuzt zwei einzelne Individuen.
        # Individuum x Individuum -> (list Individuum Individuum)
        vorn,hinten = waehlePositionen(len(individuum1)-2) # Raender weg!
        vorn+=1
        hinten+=1
        cut1=individuum1[vorn:hinten]
        cut2=individuum2[vorn:hinten]
        neu1 = individuum1[:vorn]+cut2+individuum1[hinten:]
        neu2 = individuum2[:vorn]+cut1+individuum2[hinten:]
        return neu1,neu2

    def kreuzen(self, population, pCrossingOver):
        # Steuert das Kreuzen für die gesamte Population.
        # Da beim Kreuzen neue Individuen erzeugt und der Population hinzu-
        # gefügt werden, ändert sich die Gesamtzahl. Deren Anpassung erfolgt
        # bei der Selektion.
        # Die zu kreuzenden Individuen werden nach dem Zufallsprinzip ausge-
        # wählt.
        # Parameter sind: Population, crossing-over-Wahrscheinlichkeit
        # Wert:  Population zuzüglich der Gekreuzten
        alleGekreuzten = []
        n=len(population)
        for individuum in population:
            if aktionP(pCrossingOver):
                anderes = population[random.randint(0,n-1)]
                while anderes == individuum:
                    anderes = population[random.randint(0,n-1)]
                gekreuzt1,gekreuzt2=self.kreuze(individuum,anderes)
                alleGekreuzten+=[gekreuzt1,gekreuzt2]
        return population+alleGekreuzten

    def selektiere(self, individuum1, individuum2):
        # Selektiert von zwei Individuen das mit der höheren Bewertungszahl.
        if besserP(individuum1, individuum2, self.verzoegerungsFaktor):
            return individuum1
        return individuum2

    def selektion(self, population, gesamtzahl):
        # Es gibt viele veschiedene Selektionsmechanismen. Beispielsweise
        # kann die Auswahl proportional zur Bewertungsfunktion erfolgen.
        # Hier werden die vorhandenen Individuen einfach zufällig ausgewählt
        # und einer paarweisen Auswahl unterzogen: Selektiert wird aus der
        # Menge der Individuen durch direkten Vergleich von je zwei
        # Individuen. Der Parameter Gesamtzahl gewährleistet, dass wieder
        # die ursprüngliche Populationsgrösse hergestellt wird.
        # Dazu wird mit der Selektion abgebrochen, wenn eine genügend grosse
        # Zahl (-> Gesamtzahl) ausgewählt wurde. (geaendert))
        # Am Beginn wird die aktuell beste Tour zusaetzlich eingefuegt:
        ##population.insert(int(len(population)/3),self.bestesIndividuum(population))
        akku = [self.bestesIndividuum(population)]
        while gesamtzahl > len(akku):
            pos1,pos2 = waehlePositionen(len(population))
            akku.append(self.selektiere(population[pos1],population[pos2]))
        return akku

    def bewertung(self, population):
        # Führt die Bewertung der gesamten Population durch. Dazu wird die 
        # Populationsliste in eine Liste mit Paaren [Individuum Bewertung]
        # verwandelt;
        # wird (noch?) nicht verwendet
        akku = []
        for i in range(len(population)):
            akku.append([population[i],bewerte(population[i],self.verzoegerungsFaktor)])
        return akku

    def bestesIndividuum(self, population):
        # Für die grafische Darstellung, aber auch für das Ergebnis des GA
        # ist es sinnvoll, das 'beste' Individuum bestimmen zu können.
        indexBestes = 0
        for i in range(1,len(population)):
##            print()
##            input((population[i],population[indexBestes]))
            if besserP(population[i],population[indexBestes],self.verzoegerungsFaktor):
                indexBestes = i
        return population[indexBestes]

    def gibSchrittDaten(self):
        return self.schrittDaten
    
    def sichereBeste(self,tour):
        # sichert die Daten der jeweils besten Touren
        wert=bewerte(tour,self.verzoegerungsFaktor)
        self.schrittDaten.append([tour,wert])

    def gibBeste(self):
        if self.schrittDaten==[]: return []
        return self.schrittDaten[len(self.schrittDaten)-1]
        
    def loescheBeste(self):
        self.schrittDaten=[]

    def ausgabe(self, individuum):
        # Fuer die Ausgabe der ('besten') Loesungen in der Shell
        print(individuum," --> ",bewerte(individuum,self.verzoegerungsFaktor))

    def genetischerAlgorithmus(self,
                               populationsGroesse,
                               anzahlSchritte,
                               mutationsWahrscheinlichkeit,
                               crossingOverWahrscheinlichkeit):
        "Der eigentliche Prozess"
        population = self.erzeugePopulation(populationsGroesse)
        self.loescheBeste()
        self.ausgabe(self.bestesIndividuum(population))
        for i in range(anzahlSchritte):
            population= self.selektion(self.kreuzen(self.mutation(population,
                                                                  mutationsWahrscheinlichkeit),
                                                    crossingOverWahrscheinlichkeit),
                                       populationsGroesse)
            self.sichereBeste(self.bestesIndividuum(population))
        beste=self.bestesIndividuum(population)
        return [beste,bewerte(beste,self.verzoegerungsFaktor)]

    def gA_Neu(self,
               anzahl,
               populationsGroesse,
               anzahlSchritte,
               mutationsWahrscheinlichkeit,
               crossingOverWahrscheinlichkeit):
        "Aufruf, der die Orteliste neu erzeugt"
        self.setzeAnzahlOrte(anzahl)
        beste=self.genetischerAlgorithmus(populationsGroesse,
                                          anzahlSchritte,
                                          mutationsWahrscheinlichkeit,
                                          crossingOverWahrscheinlichkeit)
        return beste

### Tests
##wegGA = WegGA()
##weg1=wegGA.erzeugeIndividuum()
##print(weg1)
##weg2=wegGA.erzeugeIndividuum()
##print(weg2,'\n')
##gekreuzt=wegGA.kreuze(weg1,weg2)
##print(gekreuzt)
##print(gekreuzt[0])
##print(gekreuzt[1])
##weg3=wegGA.erzeugeIndividuum()
##print(wegGA.kreuzen([weg1,weg2,weg3],80))
##wegGA.genetischerAlgorithmus(20,10,20,20)
##print(len(wegGA.gibOrte()))
##print(len(wegGA.gibSchrittDaten()))
##wegGA.gibBeste()
##wegGA.gA_Neu(3,20,10,20,20)
##print(len(wegGA.gibOrte()))
##print(len(wegGA.gibSchrittDaten()))
##wegGA.gibBeste()
